<!-- eslint-disable vue/no-dupe-keys -->
<script setup lang="ts">
import { type User } from '@/types/User'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import UserCard from './UserCard.vue'
import { useUserStore } from '@/stores/user'
import { useBranchStore } from '@/stores/branch'
import { useAuthStore } from '@/stores/auth'
import Swal from 'sweetalert2'

const props = defineProps<{
  users: User[]
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

function selected(p: User) {
  emit('selectedUser', p)
}

const userStore = useUserStore()
const branchStore = useBranchStore()
const authStore = useAuthStore()

const dialog = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
const users = ref<User[]>([])
const show = ref(false)

function onSubmit() {}

async function getUser() {
  if (authStore.getCurrentUser()?.role === 'Owner') {
    users.value = userStore.users
    console.log('Owner')
  } else if (authStore.getCurrentUser()?.role === 'Manager') {
    users.value = branchStore.userAtBranch
    console.log('Manager')
  }
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  const id = userStore.users;
  const isUsernameTaken = id.some(user => user.username === userStore.editedUser.username && user.id !== userStore.editedUser.id);
  const isEmailTaken = id.some(user => user.email === userStore.editedUser.email && user.id !== userStore.editedUser.id);

// Check if username or email is taken
if (isUsernameTaken || isEmailTaken) {
    Swal.fire({ icon: 'error', title: 'Warning', text: 'Username or Email is already taken', customClass: { container: 'my-swal' } });
    return;
}

// Check if any required fields are empty
if (!userStore.editedUser.username || !userStore.editedUser.email || !userStore.editedUser.fullName) {
    Swal.fire({ icon: 'error', title: 'Warning', text: 'Please fill in all required fields', customClass: { container: 'my-swal' } });
    return;
}
  await userStore.saveUser()
  closeDialog()
  
  // refreshPage()
}

function refreshPage() {
  window.location.reload()
}
// function checkUsernameUnique(username : string){
//     if (userStore.editedUser.username.includes(userStore.editedUser.username)) {
//       return ('Username Already Taken');
//     } else {
//       return userStore.editedUser.username.push(userStore.editedUser.username);
//     }
//   }

onMounted(async () => {
  await branchStore.getBranchs()
  await userStore.getUsersByBranch(authStore.getCurrentUser()?.branch?.id!)
  getUser()
})
const email = ref('')
function validateEmail(value: any) {
  const emailRegex = /^[a-zA-Z0-9._%+-]+@(gmail|hotmail)\.com$/

  return emailRegex.test(value) || 'Invalid email address'
}
</script>
<template>
  <div style="position: relative; overflow-y: auto">
    <v-toolbar flat style="background-color: #212121; color: white">
      <v-toolbar-title>Employee</v-toolbar-title>
    </v-toolbar>

    <v-dialog v-model="dialog" persistent width="1024" style="z-index: 1">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" color="#c7a17a" class="new-user-btn"> New User </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">User</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.email"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Invalid Email', validateEmail]"
                    class="mb-2"
                    clearable
                    label="Email"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.fullName"
                    :readonly="loading"
                    :rules="[(v) => !/[^a-zA-Zก-ฮะ-ะ๐-๙ ]/.test(v) || 'Invalid Full Name']"
                    class="mb-2"
                    clearable
                    label="Full Name"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.username"
                    :readonly="loading"
                    :rules="[(v) => !/[^a-zA-Zก-ฮะ-ะ๐-๙ ]/.test(v) || 'Invalid Username']"
                    class="mb-2"
                    clearable
                    label="Username"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.password"
                    :readonly="loading"
                    :rules="[
                      (v) => !!v || 'Please fill data',
                      (v) =>
                        (v && v.length >= 8) ||
                        'Password must contain letters and numbers more than 8 characters',
                    ]"
                    clearable
                    label="Password"
                    placeholder="Enter your password"
                    :type="show ? 'text' : 'password'"
                    ><template v-slot:append-inner>
                      <v-icon
                        :icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                        @click="show = !show"
                      ></v-icon> </template
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="userStore.editedUser.gender"
                    :readonly="loading"
                    prepend-inner-icon="mdi-gender-male-female"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Male', value: 'male' },
                      { title: 'Female', value: 'female' },
                      { title: 'Others', value: 'others' }
                    ]"
                    label="Gender"
                    :return-object="false"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="userStore.editedUser.role"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Staff', value: 'Staff' },
                      { title: 'Manager', value: 'Manager' }
                    ]"
                    label="Role"
                    :return-object="false"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="userStore.editedUser.workType"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Part Time', value: 'PT' },
                      { title: 'Full Time', value: 'FT' }
                    ]"
                    label="workType"
                    :return-object="false"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-combobox
                    v-model="userStore.editedUser.branch"
                    :items="branchStore.branchs"
                    item-title="name"
                    item-value="id"
                    label="Select branch"
                    :return-object="true"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="userStore.editedUser.workRate"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="workRate"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="4">
                  <v-file-input
                    v-model="userStore.editedUser.files"
                    :rules="[
                      (value) => {
                        return (
                          !value ||
                          !value.length ||
                          value[0].size < 5000000 ||
                          'Avatar size should be less than 5 MB!'
                        )
                      }
                    ]"
                    accept="image/png, image/jpeg"
                    label="Avatar"
                    placeholder="Pick an avatar"
                    prepend-icon="mdi-camera"
                  ></v-file-input>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-img
                    :src="'http://localhost:3000/images/users/' + userStore.editedUser.image"
                    width="100"
                  ></v-img>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small style="color: red">*Please fill data</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
          <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-container>
      <v-row>
        <v-col cols="12" md="3" v-for="item of users" :key="item.id">
          <UserCard :user="item" @selected-user="selected"></UserCard>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<style scoped>
.new-user-btn {
  position: relative;
  margin-top: 1%;
  left: 90%;
  margin-bottom: 20px;
}

.my-swal {
  z-index: X;
}
</style>
